#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <windows.h>
#include <math.h>
#include <GL/glut.h>

/* ֐vg^Cv */
void setvalue(void);
void setrandom(void);
int DeltaE(int,int);
void Metropolis(int);
void StepMetropolis(int,int);

static int g_array[50][50];
static int g_arraysize = 50;
static int g_Temperature = 300;

void display(void)
{
  double dx = (double)2/(g_arraysize+2);
  int i,j;

  glClear(GL_COLOR_BUFFER_BIT);
  for(i=0;i<g_arraysize;++i){
	  for(j=0;j<g_arraysize;++j){
		glBegin(GL_POLYGON);
		glColor3d((g_array[i][j]+1)/2, 0.0, 0.0);
		glVertex2d(-1.0+dx*(i+1), -1.0+dx*(j+1));
		glVertex2d(-1.0+dx*(i+2), -1.0+dx*(j+1));
		glVertex2d(-1.0+dx*(i+2), -1.0+dx*(j+2));
		glVertex2d(-1.0+dx*(i+1), -1.0+dx*(j+2));
		glEnd();
	  }
  }

  glFlush();

}

void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    if (state == GLUT_DOWN) {
		StepMetropolis(100,50);
    }
    break;
  case GLUT_RIGHT_BUTTON:
    if (state == GLUT_DOWN) {
        Metropolis(g_Temperature);
	    glutPostRedisplay();
	}
    break;
  default:
    break;
  }
}

void init(void)
{
  glClearColor(1.0, 1.0, 1.0, 1.0);
}

void onestep(int value) {
	Metropolis(value);
	glutPostRedisplay();
}


int main(int argc, char *argv[])
{
  srand( (unsigned)time(NULL) );
  setrandom();

  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);

  glutMouseFunc(mouse);

  init();

  glutMainLoop();
  return 0;
}

void setvalue(void){
	int i,j;

	for(i=0; i<g_arraysize; ++i){
		for(j=0; j<g_arraysize; ++j){
			g_array[i][j]=1;
		}
	}
}

void setrandom(void){
	int i,j;

	for(i=0; i<g_arraysize; ++i){
		for(j=0; j<g_arraysize; ++j){
			if((double)rand()/32767 <= 0.5){g_array[i][j] = -1;}
			else{g_array[i][j] = 1;}
		}
	}
}

int DeltaE(int i,int j){
	int left,right,up,down;
	if(i==0){left = g_array[g_arraysize-1][j];}else{left = g_array[i-1][j];}
	if(i==g_arraysize-1){right = g_array[0][j];}else{right = g_array[i+1][j];}
	if(j==g_arraysize-1){up = g_array[i][0];}else{up = g_array[i][j+1];}
	if(j==0){down = g_array[i][g_arraysize-1];}else{down = g_array[i][j-1];}
	return 2*g_array[i][j]*(left+right+up+down);
}

void Metropolis(int T){
	int i,j,step;
	double random;
	for(step=0; step<g_arraysize*g_arraysize; ++step){
		i = rand()%g_arraysize;
		j = rand()%g_arraysize;
		random = (double)rand()/32767;
		if(random <= exp(-(double)DeltaE(i,j)/T)){
			g_array[i][j] = -g_array[i][j];
		}
	}
}

void StepMetropolis(int steps,int delay){
	int i;
	for(i=0;i<steps;++i){
		glutTimerFunc(delay*(i+1) , onestep , g_Temperature);
	}
}